#!/bin/bash

containsElement () {
  local e
  for e in "${@:2}"; do [[ "$e" == "$1" ]] && return 0; done
  return 1
}

command=$1
exclude_patterns=buildscripts/excluded_files_with_tabs.txt
fileswithtabs=( `find . -name "*.pl" | grep -v -f "$exclude_patterns" | tr "\n" "\0" | xargs -0 grep -0 -l $'\t'` )
known_files_with_tabs=buildscripts/known_files_with_tabs.txt

case $command in
check)
  allowed_files=( `cat "$known_files_with_tabs"` )
  for x in "${fileswithtabs[@]}"
  do
    if containsElement "$x" "${allowed_files[@]}"; then
      true
    else
      echo "Introduced tab(s) into file: $x"
      grep -n $'\t' "$x" | sed 's/\t/<<TAB>>/g'
      exit 1
    fi
  done
  ;;
count)
  for x in "${fileswithtabs[@]}"
  do
    if grep -q $'\t' "$x"; then
      echo `egrep -c $'\t' "$x"` $x
    fi
  done | sort -n
  ;;
list)
  for x in "${fileswithtabs[@]}"; do echo $x; done
  ;;
store)
  $0 list > "$known_files_with_tabs"
  ;;
*)
  echo "Usage $0 check|count|list"
  exit 1
esac
