#!/bin/sh

buildscript_dir=`dirname $0`
supported_file="$buildscript_dir/supported_glibc_versions"

for objfile in "$@" ; do
  objdump -T "$objfile" \
   | fgrep GLIBC_ \
   | perl -p -e 's#^.* GLIBC_(\d+\.\d+)((.\d+)| ).*$#$1#g' \
   | sort | uniq \
   | fgrep -v -f "$supported_file" -q
  if [ $? -eq "0" ]; then
    unsupported_found=true
    echo "Unsupported clibc version in '$objfile' detected:"
    objdump -T "$objfile" \
     | fgrep GLIBC_ \
     | perl -p -e 's#^.* GLIBC_(\d+\.\d+)((.\d+)| ).*$#$1#g' \
     | sort | uniq \
     | fgrep -v -f "$supported_file"
  fi
done

if [ -n "$unsupported_found" ]; then
  exit 255
fi
