#ifndef LTLARRAY_H
#define LTLARRAY_H

#include <stdlib.h>

typedef void (*initfunction)(void *);

typedef struct {
  /* name of the array */
  const char *name;
  /* size of one element in the array */
  size_t unit;
  /* current store size (no of elements) */
  unsigned int size;
  /* number of allocated pages */
  unsigned int allocated;
  /* number */
  unsigned int regsize;
  /* pointer to list of pages */
  void **reg;
  /* pointer to init function */
  initfunction init;
} ltlarray;


void init_array(ltlarray *st, size_t unitlength, initfunction init, const char *name);
void delete_array(ltlarray *st);
int assure_arraysize(ltlarray *st, unsigned int size);
void *get_array_element(ltlarray *st, unsigned int id);
size_t ltl_array_memory_usage(ltlarray *st);

#define array_pagesize_log2 14
#define array_pagesize_abs (1 << array_pagesize_log2)

#endif
