#include <iostream>
using std::cout;
using std::endl;

#include <map>

typedef std::multimap< int, double, std::less< int > > Mymultimap;
int main()
{
   std::multimap< int, double, std::less< int > > pairs; // declare the multimap pairs

   cout << "There are currently " << pairs.count( 15 )
      << " pairs with key 15 in the multimap\n";

   // insert two value_type objects in pairs
   pairs.insert( Mymultimap::value_type( 15, 2.7 ) );
   pairs.insert( Mymultimap::value_type( 15, 99.3 ) );
   pairs.insert( Mymultimap::value_type( 16, 99.1 ) );
   pairs.insert( Mymultimap::value_type( 16, 99.5 ) );
   pairs.insert( Mymultimap::value_type( 14, 199.5 ) );
   pairs.insert( Mymultimap::value_type( 22, 199.5 ) );

   cout << "After inserts, there are " << pairs.count( 15 )
      << " pairs with key 15\n\n";

   // use const_iterator to walk through elements of pairs
   for ( Mymultimap::const_iterator iter =pairs.begin();
      iter != pairs.end(); ++iter )
      cout << iter->first << '\t' << iter->second << '\n';

   Mymultimap::iterator it = pairs.find(14);
   cout << "14: " << '\t' << it->second << endl;


   pairs.erase( pairs.begin() );
   pairs.erase( pairs.begin() );
   pairs.erase( 22 );
   
   cout << "Erased 2 elements + 22" <<endl;
   
   // use const_iterator to walk through elements of pairs
   for ( Mymultimap::const_iterator iter =pairs.begin();
      iter != pairs.end(); ++iter )
      cout << iter->first << '\t' << iter->second << '\n';
   
   cout << endl;
   return 0;
}
/* 
There are currently 0 pairs with key 15 in the multimap
After inserts, there are 2 pairs with key 15



 */