/*
    Title: A Profiler for SICStus Prolog
    Author: Philip Höfges
    Heinrich-Heine-University Düsseldorf
    Lehrstuhl für Softwaretechnik und Programmiersprachen
    Prof. Dr. Michael Leuschel, Sebastian Krings
*/

:- module(profiler_gui,[gui/0]).

% import gui libraries
:- use_module(library(tcltk)).
:- use_module(library(lists)).

% dynamic predicates
%    tcl: saves the working tcl for gui usage
%    rect: saves the last postion of the rectangle
:- dynamic tcl/1,rect/2.

% sets up the gui
gui :-
    tk_new([name('Output from Profiler')],Tcl),
    tcl_eval(Tcl,'source gui.tcl',_),
   % tcl_eval(Tcl,'source /Users/xxx/git_root/prob_prolog/extensions/profiler/gui.tcl',_),
    assert(tcl(Tcl)),
    tk_main_loop.

% calculate rectangle positions
rectangle(Tcl,Value,Max,A,B,A2,B) :-
    ( Max == 0 -> Width is 0; Width is (Value/Max) * 350),
    X2 is A,
    Y2 is B + Width,
    tcl_eval(Tcl, [draw_rectangle,B,A,Y2,X2],_),
    A2 is A + 15.

find_max(_,[],0).
find_max(Tcl,[List|T],Max) :-
    find_max(Tcl,T,Max2),
    List = [_|Values],
    tcl_eval(Tcl,'get_case',Case_String),
    tcl_eval(Tcl,'get_info',Info_String),
    Case is (Case_String - 48)*5,
    Info is Info_String - 48,
    Position is Case + Info,
    nth0(Position,Values,Value),
    ( Value > Max2
    -> Max is Value
    ; Max is Max2
    ).

:- public go/0.
% starts to print out the information (input: name + 25 values as list)
go :-
    built_list(L),
    tcl(Tcl),
    tcl_eval(Tcl,'delete',_),
    find_max(Tcl,L,Max),
    go(Tcl,L,10,10,Max).
go(_,[],_,_,_).
go(Tcl,[List|T],X,Y,Max) :-
    List = [Name|Values],
    tcl_eval(Tcl,'get_case',Case_String),
    tcl_eval(Tcl,'get_info',Info_String),
    tcl_eval(Tcl,[set_information,Name],_), !,
    Case is (Case_String - 48)*5,
    Info is Info_String - 48,
    Position is Case + Info,
    nth0(Position,Values,Value),
    rectangle(Tcl,Value,Max,X,Y,X2,Y2),
    go(Tcl,T,X2,Y2,Max).