#ifndef MSG_HEADERS_H_INCLUDED
#define MSG_HEADERS_H_INCLUDED

/* message types from worker to proxy */
#define IS_HASH_MSG     (1 << 0)
#define IS_RESULT_MSG   (1 << 1)
#define IS_SMALL_STATS  (1 << 3)
#define L_TRANSFER_DONE (1 << 4)
#define G_TRANSFER_DONE (1 << 5)

/* message types from proxy to master */
#define P_IS_HASH_MSG           (1 << 0)
#define P_RESULT_MSG            (1 << 1)
#define PSTATS_HAS_FULL         (1 << 2)
#define PSTATS_HAS_EMPTY        (1 << 3)
#define PSTATS_COMPLETELY_EMPTY (1 << 4)
#define PSTATS_HAS_PMS          (1 << 5)
#define PSTATS_QUEUES           (1 << 6)
#define P_TRANSFER_DONE         (1 << 7)

/* message types from master to proxy */
#define CTRL_ADD_HASHES         (1 << 0)
#define CTRL_TERM               (1 << 1)
#define CTRL_TRANSFER_TO        (1 << 2)
#define CTRL_TRANSFER_TERM      (1 << 3)
#define CTRL_STOP_SUCC          (1 << 4)
#define CTRL_ADD_HASHES_COMPACT (1 << 5) // a single message, no frames


/* message types from proxy to worker */
#define P_TERM           (1 << 1)
#define L_TRANSFER_TO    (1 << 2)
#define G_TRANSFER_TO    (1 << 3)
#define P_TRANSFER_ALL   (1 << 4)
#define P_STOP_SUCC      (1 << 5)

/* message types from worker to worker */
#define LOCAL_TRANSFER   (1 << 0)
#define GLOBAL_TRANSFER  (1 << 1)

/* message types from master to worker */
#define CHECK_THIS       (1 << 2)
#define TRANSFER_ACK     (1 << 3)


/* message types for REQ-REP for proxy */
/* request headers */
#define W_ID_REQUEST     (1 << 0)
#define PING             (1 << 1)

/* reply headers */
#define PONG             (1 << 1)

#define P_ID_REQ         (1 << 0)
#define P_ID_REQ_TRIE_UP (1 << 1)

#endif
