#ifndef TRANSITION_TRIE_H_INCLUDED
#define TRANSITION_TRIE_H_INCLUDED

#include <stdint.h>
#include "hash.h"
#include "hashtrie.h"

typedef struct transition {
    char *digest;
    // TODO: somehow add transition here
} transition;

typedef transition* transition_chunk;

typedef struct transition_chunks {
    transition_chunk *chunks;
    size_t size;
} transition_chunks;


typedef struct hash_list {
    char hash[HASH_LEN];
    struct hash_list *next;
} hash_list;

void put_predecessor(transition_chunks *transitions,
                     const hashtrie t,
                     char const * const hash_from,
                     char const * const hash_to);

hash_list *generate_trace(const hashtrie t,
                          transition_chunks const * const transitions,
                          char const * const hash_to);

void teardown_hash_list(hash_list **l);
#endif
