:- module(master, [start_master/8
                  % , hash_matches/2 % no longer exported
                  ]).

:- use_module(library(fastrw),[ fast_buf_read/2,fast_buf_write/3 ]).
:- use_module('../../../src/module_information.pl').
:- use_module('../zmq.pl', [init_zmq/0, master_main/10, alloc_term/3]).

:- module_info(group,experimental).
:- module_info(description,'This is the interface to C code for distributed model checking.').
:- module_info(revision,'$Rev: 9609 $').
:- module_info(lastchanged,'$LastChangedDate: 2011-11-18 10:43:02 +0100 (Fr, 18 Nov 2011) $').

%get_initialisation(Term) :-
%  consult('/Users/bendisposto/Puzzle.eventb'),
%  package(Term),
%  (Term = load_event_b_project(_A,_B,_C,_D) -> true ; print(err(Term)),nl).

:- dynamic assertion_count/1.

get_first_workpackage(assertions(_,_,_),assertions) :-
    assertion_count(N),
    print(nr_of_assertions(N)),nl,flush_output,
    set_assertion_mode(N).
get_first_workpackage(_,state(root)).

:- use_module(probsrc(error_manager)).
set_assertion_mode(N) :- add_error(zmq,'Note yet implemented:',set_assertion_mode(N)).

%hash_matches(State,Hash) :-
%   init_zmq_master,
%   fast_buf_write(State,_Len1,_Addr1),
%   gen_hash(_Addr1,_Len1,Hash).

:- use_module(probsrc(debug)).

% TODO: Recovery is not yet implemented
start_master(Term,MaxStates,PortStart,Strict,MasterIP,Logfile,TmpDir,HashCycle) :-
    init_zmq,
    get_first_workpackage(Term,WP),
    fast_buf_write(Term,Len1,Addr1),
    print(size_model(Len1)),nl,flush_output,
    alloc_term(Addr1, Len1, ModelChunk),
    fast_buf_write(WP,Len2,Addr2),
    alloc_term(Addr2, Len2, FWPChunk),
    (debug_mode(off) -> Level = 20 ; debug_level(Level)),
    %AssertionMode = 0,
    master_main(PortStart, MaxStates, Strict, ModelChunk, FWPChunk, MasterIP, Logfile, TmpDir,HashCycle,RetVal), !,
    print(retval(RetVal)),nl,flush_output,
    RetVal == 0.

%find_hash(H,ID,B) :-
%   state_space:visited_expression(ID,B),
%   hash_matches(state(B),H).
