#ifndef MPULL_H_INCLUDED
#define MPULL_H_INCLUDED

#include <zmq.h>
#include <czmq.h>
#include <stdio.h>

#include "../common/hashtrie.h"

#include "mstats.h"
#include "mid.h"

struct worker_queuesizes {
    size_t len;
    zmsg_t **queue_msgs;
    int update_count;
};

int master_h_pull(zsock_t * const pull,
                  zsock_t * const pub_cmds,
                  zsock_t * const pub_hashes,
                  const int strict,
                  mStats * const stats,
                  struct id_map const * const ips,
                  const int fd_logfile,
                  struct worker_queuesizes * const print_queues,
                  const int max_states,
                  const hashtrie trie,
                  FILE *msg_log,
                  zlist_t *hash_accumulator);

zsock_t *master_setup_pub(const int port);
zsock_t *master_setup_pull(const int port);

void send_hashes(zsock_t *pub_hashes, zlist_t *list, const int fd_logfile);

struct mpull_arg {
    zsock_t *pub_cmds;
    zsock_t *pub_hashes;
    int strict;
    mStats * stats;
    struct id_map *ips;
    int fd_logfile;
    struct worker_queuesizes *worker_queues;
    int max_states;
    hashtrie trie;
    FILE *msg_log;
    zlist_t *hash_accumulator;
};

int mpull_reader(zloop_t *loop, zsock_t *reader, void *args);
void shutdown_everything(zsock_t * const pub);

void teardown_worker_queuesizes(struct worker_queuesizes * print_queues);
void put_wqueues_msg(struct worker_queuesizes * const print_queues,
                     zmsg_t * const msg);

#endif
