% (c) 2009-2019 Lehrstuhl fuer Softwaretechnik und Programmiersprachen,
% Heinrich Heine Universitaet Duesseldorf
% This software is licenced under EPL 1.0 (http://www.eclipse.org/org/documents/epl-v10.html)

:- module(kernel_propagation,
 [ do_not_enumerate_binary_boolean_operator/3
   ]).



:- use_module(module_information,[module_info/2]).
:- module_info(group,kernel).
:- module_info(description,'This module has rules about when and how to propagate in the ProB kernel.').



% avoid enumerating possible values for arguments:
do_not_enumerate_binary_boolean_operator(subset,LHS,_) :- cannot_propagate_value_to_expr(LHS).

cannot_propagate_value_to_expr(b(E,T,_)) :- cannot_propagate(E,T).
% we cannot effectively propagate values to such expressions
cannot_propagate(domain(_),_).  % when knowing dom(f) we cannot derive f
cannot_propagate(range(_),_).
%cannot_propagate(_,_).
% TO DO: unary_in_boolean_type(pow_subset,kernel_objects:check_subset_of_wf).
% unary_in_boolean_type(fin_subset,kernel_objects:check_finite_subset_of_wf).
% unary_in_boolean_type(pow1_subset,kernel_objects:check_non_empty_subset_of_wf).


