% (c) 2016-2019 Lehrstuhl fuer Softwaretechnik und Programmiersprachen,
% Heinrich Heine Universitaet Duesseldorf
% This software is licenced under EPL 1.0 (http://www.eclipse.org/org/documents/epl-v10.html)

:- module(performance_messages,
  [
   performance_monitoring_on/0,
   perfmessage/1, perfmessage/2,
   perfmessagecall/2, perfmessagecall/3,
   toggle_perfmessages/0
   ]).

:- use_module(preferences).
:- use_module(error_manager).

% -------------------------------------------

:- dynamic performance_monitoring_on/0. % should we use a preference
%performance_monitoring_on.

performance_monitoring_on :- get_preference(performance_monitoring_on,true).

toggle_perfmessages :- print('TURNING PERF-MESSAGES '),
  (performance_monitoring_on
   -> set_preference(performance_monitoring_on,false), print('OFF')
    ; set_preference(performance_monitoring_on,true), print('ON')),nl.

perfmessage(M) :- preference(performance_monitoring_on,true),!,
   format(user_output,'==PERF-MESSAGE==> ~w~n',[M]).
perfmessage(_).

perfmessage(M,Location) :- preference(performance_monitoring_on,true),!,
   add_warning(performance_message,'==PERF-MESSAGE==> ',M,Location).
perfmessage(_,_).

:- meta_predicate perfmessagecall(*,0).
perfmessagecall(M,Call) :- preference(performance_monitoring_on,true),!,
   format(user_output,'==PERF-MESSAGE==> ~w : ',[M]),
   call(Call),nl(user_output).
perfmessagecall(_,_).

:- meta_predicate perfmessagecall(*,0,*).
perfmessagecall(M,Call,Location) :- preference(performance_monitoring_on,true),!,
   call(Call),nl(user_output),
   add_warning(performance_message,'==PERF-MESSAGE==> ',M,Location).
perfmessagecall(_,_,_).
