% (c) 2009-2019 Lehrstuhl fuer Softwaretechnik und Programmiersprachen,
% Heinrich Heine Universitaet Duesseldorf
% This software is licenced under EPL 1.0 (http://www.eclipse.org/org/documents/epl-v10.html)

:- module(user_interrupts,[interruptable_call/1, interruptable_call/2,
       catch_interrupt_assertion_call/1,
       process_interrupted_error_message/0]).

:- use_module(module_information).

:- module_info(group,infrastructure).
:- module_info(description,'This module allows to call predicates which can be interrupted by cntrl-c.').

:- use_module(error_manager).

%:- use_module(extension('user_signal/user_signal'), [get_user_signal_ref/1]).
:- meta_predicate catch_interrupt_assertion_call(0).
catch_interrupt_assertion_call(Call) :-
   on_exception(error(forced_interrupt_error('User has interrupted the current execution'),_),
                Call,
                (process_interrupted_error_message,fail)).

process_interrupted_error_message :-
    add_error(probcli,'User has interrupted current execution.').


:- use_module(extension('user_signal/user_signal'), [user_interruptable_call_det/2]).
:- meta_predicate interruptable_call(0).
interruptable_call(Call) :-
   user_interruptable_call_det(catch_interrupt_assertion_call(Call),InterruptResult),
   (InterruptResult=interrupted -> print(' **KeyboardInterrupt**'),nl,fail; otherwise -> true).

:- meta_predicate interruptable_call(0,-).
interruptable_call(Call,InterruptResult) :-
   user_interruptable_call_det(catch_interrupt_assertion_call(Call),InterruptResult),
   (InterruptResult=interrupted -> print(' **KeyboardInterrupt**'),nl; otherwise -> true),
   print(interruptable_call(Call,InterruptResult)),nl.

