:- module(fastload, [ write_term_to_file/2
                    , read_term_from_file/2]).

:- use_module(library(fastrw),[ fast_buf_read/2,fast_buf_write/3 ]).

foreign_resource(fastload,[ write_to_file, read_from_file]).
foreign(write_to_file, write_to_file(+address(char),+integer, +string)).
foreign(read_from_file, read_from_file(+string, -address)).

:- load_foreign_resource(fastload).

write_term_to_file(Term, File) :-
    fast_buf_write(Term,Len,Addr),
    write_to_file(Addr, Len, File).

read_term_from_file(File, Term) :-
    read_from_file(File, Addr),
    fast_buf_read(Term, Addr).
